/**
 * 3Di API
 * 3Di simulation API (latest stable version: v3)   Framework release: 3.0.1   3Di core release: 2.3.0.dev0  deployed on:  10:42AM (UTC) on October 04, 2022
 *
 * The version of the OpenAPI document: v3
 * Contact: info@nelen-schuurmans.nl
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import * as runtime from '../runtime';
import { BaseEventState, CurrentVersion, InlineResponse200, InlineResponse2001, ObstacleEdit, PersonalAPIKey, PersonalAPIKeyWithSecret, RasterEditUrls, Status } from '../models';
export interface PersonalapikeysCreateRequest {
    data: PersonalAPIKey;
}
export interface PersonalapikeysDeleteRequest {
    prefix: string;
}
export interface PersonalapikeysListRequest {
    limit?: number;
    offset?: number;
}
export interface PersonalapikeysReadRequest {
    prefix: string;
}
export interface PersonalapikeysRevokeRequest {
    prefix: string;
}
export interface SimulationsEventsObstacleEditsCreateRequest {
    simulationPk: string;
    data: ObstacleEdit;
}
export interface SimulationsEventsObstacleEditsDeleteRequest {
    id: number;
    simulationPk: string;
}
export interface SimulationsEventsObstacleEditsListRequest {
    simulationPk: string;
    limit?: number;
    offset?: number;
}
export interface SimulationsEventsObstacleEditsPartialUpdateRequest {
    id: number;
    simulationPk: string;
    data: ObstacleEdit;
}
export interface SimulationsEventsObstacleEditsProcessedRequest {
    id: number;
    simulationPk: string;
    data: BaseEventState;
}
export interface SimulationsEventsObstacleEditsReadRequest {
    id: number;
    simulationPk: string;
}
export interface SimulationsEventsObstacleEditsRegisterRelatedRastersRequest {
    id: number;
    simulationPk: string;
}
export interface SimulationsEventsObstacleEditsUpdateRequest {
    id: number;
    simulationPk: string;
    data: ObstacleEdit;
}
/**
 * no description
 */
export declare class V3BetaApi extends runtime.BaseAPI {
    /**
     * Personal API keys are used for authentication without password.
     */
    personalapikeysCreateRaw(requestParameters: PersonalapikeysCreateRequest): Promise<runtime.ApiResponse<PersonalAPIKeyWithSecret>>;
    /**
     * Personal API keys are used for authentication without password.
     */
    personalapikeysCreate(requestParameters: PersonalapikeysCreateRequest): Promise<PersonalAPIKeyWithSecret>;
    /**
     * Personal API keys are used for authentication without password.
     */
    personalapikeysDeleteRaw(requestParameters: PersonalapikeysDeleteRequest): Promise<runtime.ApiResponse<void>>;
    /**
     * Personal API keys are used for authentication without password.
     */
    personalapikeysDelete(requestParameters: PersonalapikeysDeleteRequest): Promise<void>;
    /**
     * Personal API keys are used for authentication without password.
     */
    personalapikeysListRaw(requestParameters: PersonalapikeysListRequest): Promise<runtime.ApiResponse<InlineResponse200>>;
    /**
     * Personal API keys are used for authentication without password.
     */
    personalapikeysList(requestParameters: PersonalapikeysListRequest): Promise<InlineResponse200>;
    /**
     * Personal API keys are used for authentication without password.
     */
    personalapikeysReadRaw(requestParameters: PersonalapikeysReadRequest): Promise<runtime.ApiResponse<PersonalAPIKey>>;
    /**
     * Personal API keys are used for authentication without password.
     */
    personalapikeysRead(requestParameters: PersonalapikeysReadRequest): Promise<PersonalAPIKey>;
    /**
     * Revoke an API key and return the status.
     */
    personalapikeysRevokeRaw(requestParameters: PersonalapikeysRevokeRequest): Promise<runtime.ApiResponse<PersonalAPIKey>>;
    /**
     * Revoke an API key and return the status.
     */
    personalapikeysRevoke(requestParameters: PersonalapikeysRevokeRequest): Promise<PersonalAPIKey>;
    /**
     * A simple ViewSet for viewing obstacle edits
     */
    simulationsEventsObstacleEditsCreateRaw(requestParameters: SimulationsEventsObstacleEditsCreateRequest): Promise<runtime.ApiResponse<ObstacleEdit>>;
    /**
     * A simple ViewSet for viewing obstacle edits
     */
    simulationsEventsObstacleEditsCreate(requestParameters: SimulationsEventsObstacleEditsCreateRequest): Promise<ObstacleEdit>;
    /**
     * destroy resource only if the event has not yet been applied to the associated simulation
     */
    simulationsEventsObstacleEditsDeleteRaw(requestParameters: SimulationsEventsObstacleEditsDeleteRequest): Promise<runtime.ApiResponse<void>>;
    /**
     * destroy resource only if the event has not yet been applied to the associated simulation
     */
    simulationsEventsObstacleEditsDelete(requestParameters: SimulationsEventsObstacleEditsDeleteRequest): Promise<void>;
    /**
     * A simple ViewSet for viewing obstacle edits
     */
    simulationsEventsObstacleEditsListRaw(requestParameters: SimulationsEventsObstacleEditsListRequest): Promise<runtime.ApiResponse<InlineResponse2001>>;
    /**
     * A simple ViewSet for viewing obstacle edits
     */
    simulationsEventsObstacleEditsList(requestParameters: SimulationsEventsObstacleEditsListRequest): Promise<InlineResponse2001>;
    /**
     * when the simulation has started only the duration parameter might be patched
     */
    simulationsEventsObstacleEditsPartialUpdateRaw(requestParameters: SimulationsEventsObstacleEditsPartialUpdateRequest): Promise<runtime.ApiResponse<void>>;
    /**
     * when the simulation has started only the duration parameter might be patched
     */
    simulationsEventsObstacleEditsPartialUpdate(requestParameters: SimulationsEventsObstacleEditsPartialUpdateRequest): Promise<void>;
    /**
     * A simple ViewSet for viewing obstacle edits
     */
    simulationsEventsObstacleEditsProcessedRaw(requestParameters: SimulationsEventsObstacleEditsProcessedRequest): Promise<runtime.ApiResponse<void>>;
    /**
     * A simple ViewSet for viewing obstacle edits
     */
    simulationsEventsObstacleEditsProcessed(requestParameters: SimulationsEventsObstacleEditsProcessedRequest): Promise<void>;
    /**
     * A simple ViewSet for viewing obstacle edits
     */
    simulationsEventsObstacleEditsReadRaw(requestParameters: SimulationsEventsObstacleEditsReadRequest): Promise<runtime.ApiResponse<ObstacleEdit>>;
    /**
     * A simple ViewSet for viewing obstacle edits
     */
    simulationsEventsObstacleEditsRead(requestParameters: SimulationsEventsObstacleEditsReadRequest): Promise<ObstacleEdit>;
    /**
     * Skips registering of related rasters when the simulation is not in the state \'starting\' or \'initialized\'. In this case the urls will be empty
     * Register all related rasters in the results-api and return read_bbox urls of the registered rasters
     */
    simulationsEventsObstacleEditsRegisterRelatedRastersRaw(requestParameters: SimulationsEventsObstacleEditsRegisterRelatedRastersRequest): Promise<runtime.ApiResponse<Array<RasterEditUrls>>>;
    /**
     * Skips registering of related rasters when the simulation is not in the state \'starting\' or \'initialized\'. In this case the urls will be empty
     * Register all related rasters in the results-api and return read_bbox urls of the registered rasters
     */
    simulationsEventsObstacleEditsRegisterRelatedRasters(requestParameters: SimulationsEventsObstacleEditsRegisterRelatedRastersRequest): Promise<Array<RasterEditUrls>>;
    /**
     * A simple ViewSet for viewing obstacle edits
     */
    simulationsEventsObstacleEditsUpdateRaw(requestParameters: SimulationsEventsObstacleEditsUpdateRequest): Promise<runtime.ApiResponse<ObstacleEdit>>;
    /**
     * A simple ViewSet for viewing obstacle edits
     */
    simulationsEventsObstacleEditsUpdate(requestParameters: SimulationsEventsObstacleEditsUpdateRequest): Promise<ObstacleEdit>;
    /**
     */
    statusCurrentVersionRaw(): Promise<runtime.ApiResponse<CurrentVersion>>;
    /**
     */
    statusCurrentVersion(): Promise<CurrentVersion>;
    /**
     */
    statusListRaw(): Promise<runtime.ApiResponse<Status>>;
    /**
     */
    statusList(): Promise<Status>;
}
