/**
 * 3Di API
 * 3Di simulation API (latest stable version: v3)   Framework release: 3.0.1   3Di core release: 2.3.0.dev0  deployed on:  10:42AM (UTC) on October 04, 2022
 *
 * The version of the OpenAPI document: v3
 * Contact: info@nelen-schuurmans.nl
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
/**
 *
 * @export
 * @interface AggregationSettings
 */
export interface AggregationSettings {
    /**
     *
     * @type {string}
     * @memberof AggregationSettings
     */
    readonly url?: string;
    /**
     * Give your aggregation setting a name to be able to find it back in the results file.
     * @type {string}
     * @memberof AggregationSettings
     */
    name?: string | null;
    /**
     * Options:  water_level = Water Level flow_velocity = Flow Velocity discharge = Discharge volume = Volume pump_discharge = Pump Discharge wet_cross_section = Wet Cross Section lateral_discharge = Lateral Discharge wet_surface = Wet Surface rain = Rain simple_infiltration = Simple Infiltration leakage = Leakage interception = Interception surface_source_sink_discharge = Surface Source Sink Discharge
     * @type {string}
     * @memberof AggregationSettings
     */
    flowVariable: AggregationSettingsFlowVariableEnum;
    /**
     * Options:  min = minimum value of the variable in the configured interval max = maximum value of the variable in the configured interval avg = average value of the variable in the configured interval cum = variable integration over time [dt * variable] cum_positive = variable integration over time [dt * variable] in positive direction cum_negative = variable integration over time [dt * variable] in negative direction current = current value of a variable sum = variable summation over configured interval  Note: \'current\' is required in case one checks the water balance for variables that are the result of the processes. Only valid for flow_variable \'volume\' and \'intercepted_volume\'
     * @type {string}
     * @memberof AggregationSettings
     */
    method: AggregationSettingsMethodEnum;
    /**
     * aggregation interval in seconds
     * @type {number}
     * @memberof AggregationSettings
     */
    interval: number;
}
export declare function AggregationSettingsFromJSON(json: any): AggregationSettings;
export declare function AggregationSettingsToJSON(value?: AggregationSettings): any;
/**
* @export
* @enum {string}
*/
export declare enum AggregationSettingsFlowVariableEnum {
    WaterLevel = "water_level",
    FlowVelocity = "flow_velocity",
    Discharge = "discharge",
    Volume = "volume",
    PumpDischarge = "pump_discharge",
    WetCrossSection = "wet_cross_section",
    LateralDischarge = "lateral_discharge",
    WetSurface = "wet_surface",
    Rain = "rain",
    SimpleInfiltration = "simple_infiltration",
    Leakage = "leakage",
    Interception = "interception",
    SurfaceSourceSinkDischarge = "surface_source_sink_discharge"
}
/**
* @export
* @enum {string}
*/
export declare enum AggregationSettingsMethodEnum {
    Min = "min",
    Max = "max",
    Avg = "avg",
    Cum = "cum",
    CumPositive = "cum_positive",
    CumNegative = "cum_negative",
    Current = "current",
    Sum = "sum"
}
