/**
 * 3Di API
 * 3Di simulation API (latest stable version: v3)   Framework release: 3.0.1   3Di core release: 2.3.0.dev0  deployed on:  10:42AM (UTC) on October 04, 2022
 *
 * The version of the OpenAPI document: v3
 * Contact: info@nelen-schuurmans.nl
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
/**
 *
 * @export
 * @interface ConstantWind
 */
export interface ConstantWind {
    /**
     *
     * @type {number}
     * @memberof ConstantWind
     */
    readonly id?: number;
    /**
     *
     * @type {string}
     * @memberof ConstantWind
     */
    readonly uid?: string;
    /**
     *
     * @type {string}
     * @memberof ConstantWind
     */
    readonly url?: string;
    /**
     *
     * @type {string}
     * @memberof ConstantWind
     */
    readonly simulation?: string;
    /**
     * offset of event in simulation in seconds
     * @type {number}
     * @memberof ConstantWind
     */
    offset: number;
    /**
     * event duration in seconds. -9999 is the \'infinite duration\' value (only allowed in conjunction with infinite simulations
     * @type {number}
     * @memberof ConstantWind
     */
    duration?: number | null;
    /**
     * [time, speed, direction]
     * @type {Array<Array<number>>}
     * @memberof ConstantWind
     */
    readonly values?: Array<Array<number>>;
    /**
     * wind speed unit (default \'m/s\')
     * @type {string}
     * @memberof ConstantWind
     */
    units?: ConstantWindUnitsEnum;
    /**
     * interpolate wind speed
     * @type {boolean}
     * @memberof ConstantWind
     */
    readonly speedInterpolate?: boolean;
    /**
     * constant wind speed
     * @type {boolean}
     * @memberof ConstantWind
     */
    readonly speedConstant?: boolean;
    /**
     * interpolate wind direction
     * @type {boolean}
     * @memberof ConstantWind
     */
    readonly directionInterpolate?: boolean;
    /**
     * constant wind direction
     * @type {boolean}
     * @memberof ConstantWind
     */
    readonly directionConstant?: boolean;
    /**
     * constant wind speed
     * @type {number}
     * @memberof ConstantWind
     */
    speedValue?: number;
    /**
     * constant wind direction in degrees (0-360) from north - meteorological standard (thus, 180 is a southern wind)
     * @type {number}
     * @memberof ConstantWind
     */
    directionValue?: number;
}
export declare function ConstantWindFromJSON(json: any): ConstantWind;
export declare function ConstantWindToJSON(value?: ConstantWind): any;
/**
* @export
* @enum {string}
*/
export declare enum ConstantWindUnitsEnum {
    MS = "m/s",
    KmH = "km/h"
}
