/**
 * 3Di API
 * 3Di simulation API (latest stable version: v3)   Framework release: 3.0.1   3Di core release: 2.3.0.dev0  deployed on:  10:42AM (UTC) on October 04, 2022
 *
 * The version of the OpenAPI document: v3
 * Contact: info@nelen-schuurmans.nl
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import { MeasureSpecification } from './';
/**
 *
 * @export
 * @interface MemoryStructureControl
 */
export interface MemoryStructureControl {
    /**
     *
     * @type {number}
     * @memberof MemoryStructureControl
     */
    readonly id?: number;
    /**
     *
     * @type {string}
     * @memberof MemoryStructureControl
     */
    readonly url?: string;
    /**
     * offset of event in simulation in seconds
     * @type {number}
     * @memberof MemoryStructureControl
     */
    offset: number;
    /**
     * event duration in seconds. -9999 is the \'infinite duration\' value (only allowed in conjunction with infinite simulations
     * @type {number}
     * @memberof MemoryStructureControl
     */
    duration?: number | null;
    /**
     *
     * @type {MeasureSpecification}
     * @memberof MemoryStructureControl
     */
    measureSpecification: MeasureSpecification;
    /**
     *
     * @type {number}
     * @memberof MemoryStructureControl
     */
    structureId?: number | null;
    /**
     *
     * @type {string}
     * @memberof MemoryStructureControl
     */
    structureType: MemoryStructureControlStructureTypeEnum;
    /**
     *
     * @type {string}
     * @memberof MemoryStructureControl
     */
    type: MemoryStructureControlTypeEnum;
    /**
     * list containing a single action values, e.g. [*action_value*]. For type set_discharge_coefficients two action values need to be provided, e.g. [*action_value*, *action_value*].
     * @type {Array<number>}
     * @memberof MemoryStructureControl
     */
    value: Array<number>;
    /**
     *
     * @type {string}
     * @memberof MemoryStructureControl
     */
    readonly state?: MemoryStructureControlStateEnum;
    /**
     *
     * @type {object}
     * @memberof MemoryStructureControl
     */
    readonly stateDetail?: object;
    /**
     *
     * @type {number}
     * @memberof MemoryStructureControl
     */
    gridId?: number | null;
    /**
     *
     * @type {string}
     * @memberof MemoryStructureControl
     */
    readonly uid?: string;
    /**
     * e.g. 0.3
     * @type {number}
     * @memberof MemoryStructureControl
     */
    upperThreshold?: number | null;
    /**
     * e.g. 0.3
     * @type {number}
     * @memberof MemoryStructureControl
     */
    lowerThreshold?: number | null;
    /**
     * when True the initial state of the target is active
     * @type {boolean}
     * @memberof MemoryStructureControl
     */
    isActive?: boolean;
    /**
     * when True the target will become active when the lower threshold has been reached
     * @type {boolean}
     * @memberof MemoryStructureControl
     */
    isInverse?: boolean;
}
export declare function MemoryStructureControlFromJSON(json: any): MemoryStructureControl;
export declare function MemoryStructureControlToJSON(value?: MemoryStructureControl): any;
/**
* @export
* @enum {string}
*/
export declare enum MemoryStructureControlStructureTypeEnum {
    Pumpstation = "v2_pumpstation",
    Pipe = "v2_pipe",
    Orifice = "v2_orifice",
    Culvert = "v2_culvert",
    Weir = "v2_weir",
    Channel = "v2_channel"
}
/**
* @export
* @enum {string}
*/
export declare enum MemoryStructureControlTypeEnum {
    DischargeCoefficients = "set_discharge_coefficients",
    CrestLevel = "set_crest_level",
    PumpCapacity = "set_pump_capacity"
}
/**
* @export
* @enum {string}
*/
export declare enum MemoryStructureControlStateEnum {
    Processing = "processing",
    Valid = "valid",
    Invalid = "invalid"
}
