// tslint:disable
/**
 * 3Di API
 * 3Di simulation API (latest stable version: v3)   Framework release: 3.0.1   3Di core release: 2.3.0.dev0  deployed on:  10:42AM (UTC) on October 04, 2022
 *
 * The version of the OpenAPI document: v3
 * Contact: info@nelen-schuurmans.nl
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { exists, mapValues } from '../runtime';
/**
 * 
 * @export
 * @interface Breach
 */
export interface Breach {
    /**
     * 
     * @type {string}
     * @memberof Breach
     */
    readonly url?: string;
    /**
     * 
     * @type {string}
     * @memberof Breach
     */
    potentialBreach: string;
    /**
     * 
     * @type {number}
     * @memberof Breach
     */
    readonly lineId?: number;
    /**
     * duration till maximum depth in seconds
     * @type {number}
     * @memberof Breach
     */
    durationTillMaxDepth: number;
    /**
     * Override the maximum_breach_depth of the potential breach
     * @type {number}
     * @memberof Breach
     */
    maximumBreachDepth?: number | null;
    /**
     * Override the levee_material of the potential breach
     * @type {string}
     * @memberof Breach
     */
    leveeMaterial?: BreachLeveeMaterialEnum;
    /**
     * initial width in meters
     * @type {number}
     * @memberof Breach
     */
    initialWidth: number;
    /**
     * 
     * @type {number}
     * @memberof Breach
     */
    dischargeCoefficientPositive?: number | null;
    /**
     * 
     * @type {number}
     * @memberof Breach
     */
    dischargeCoefficientNegative?: number | null;
    /**
     * 
     * @type {string}
     * @memberof Breach
     */
    readonly simulation?: string;
    /**
     * offset of event in simulation in seconds
     * @type {number}
     * @memberof Breach
     */
    offset: number;
    /**
     * 
     * @type {number}
     * @memberof Breach
     */
    readonly id?: number;
    /**
     * 
     * @type {string}
     * @memberof Breach
     */
    readonly uid?: string;
}

export function BreachFromJSON(json: any): Breach {
    return {
        'url': !exists(json, 'url') ? undefined : json['url'],
        'potentialBreach': json['potential_breach'],
        'lineId': !exists(json, 'line_id') ? undefined : json['line_id'],
        'durationTillMaxDepth': json['duration_till_max_depth'],
        'maximumBreachDepth': !exists(json, 'maximum_breach_depth') ? undefined : json['maximum_breach_depth'],
        'leveeMaterial': !exists(json, 'levee_material') ? undefined : json['levee_material'],
        'initialWidth': json['initial_width'],
        'dischargeCoefficientPositive': !exists(json, 'discharge_coefficient_positive') ? undefined : json['discharge_coefficient_positive'],
        'dischargeCoefficientNegative': !exists(json, 'discharge_coefficient_negative') ? undefined : json['discharge_coefficient_negative'],
        'simulation': !exists(json, 'simulation') ? undefined : json['simulation'],
        'offset': json['offset'],
        'id': !exists(json, 'id') ? undefined : json['id'],
        'uid': !exists(json, 'uid') ? undefined : json['uid'],
    };
}

export function BreachToJSON(value?: Breach): any {
    if (value === undefined) {
        return undefined;
    }
    return {
        'potential_breach': value.potentialBreach,
        'duration_till_max_depth': value.durationTillMaxDepth,
        'maximum_breach_depth': value.maximumBreachDepth,
        'levee_material': value.leveeMaterial,
        'initial_width': value.initialWidth,
        'discharge_coefficient_positive': value.dischargeCoefficientPositive,
        'discharge_coefficient_negative': value.dischargeCoefficientNegative,
        'offset': value.offset,
    };
}

/**
* @export
* @enum {string}
*/
export enum BreachLeveeMaterialEnum {
    Sand = 'sand',
    Clay = 'clay'
}


