// tslint:disable
/**
 * 3Di API
 * 3Di simulation API (latest stable version: v3)   Framework release: 3.0.1   3Di core release: 2.3.0.dev0  deployed on:  10:42AM (UTC) on October 04, 2022
 *
 * The version of the OpenAPI document: v3
 * Contact: info@nelen-schuurmans.nl
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { exists, mapValues } from '../runtime';
/**
 * 
 * @export
 * @interface ConstantWind
 */
export interface ConstantWind {
    /**
     * 
     * @type {number}
     * @memberof ConstantWind
     */
    readonly id?: number;
    /**
     * 
     * @type {string}
     * @memberof ConstantWind
     */
    readonly uid?: string;
    /**
     * 
     * @type {string}
     * @memberof ConstantWind
     */
    readonly url?: string;
    /**
     * 
     * @type {string}
     * @memberof ConstantWind
     */
    readonly simulation?: string;
    /**
     * offset of event in simulation in seconds
     * @type {number}
     * @memberof ConstantWind
     */
    offset: number;
    /**
     * event duration in seconds. -9999 is the \'infinite duration\' value (only allowed in conjunction with infinite simulations
     * @type {number}
     * @memberof ConstantWind
     */
    duration?: number | null;
    /**
     * [time, speed, direction]
     * @type {Array<Array<number>>}
     * @memberof ConstantWind
     */
    readonly values?: Array<Array<number>>;
    /**
     * wind speed unit (default \'m/s\')
     * @type {string}
     * @memberof ConstantWind
     */
    units?: ConstantWindUnitsEnum;
    /**
     * interpolate wind speed
     * @type {boolean}
     * @memberof ConstantWind
     */
    readonly speedInterpolate?: boolean;
    /**
     * constant wind speed
     * @type {boolean}
     * @memberof ConstantWind
     */
    readonly speedConstant?: boolean;
    /**
     * interpolate wind direction
     * @type {boolean}
     * @memberof ConstantWind
     */
    readonly directionInterpolate?: boolean;
    /**
     * constant wind direction
     * @type {boolean}
     * @memberof ConstantWind
     */
    readonly directionConstant?: boolean;
    /**
     * constant wind speed
     * @type {number}
     * @memberof ConstantWind
     */
    speedValue?: number;
    /**
     * constant wind direction in degrees (0-360) from north - meteorological standard (thus, 180 is a southern wind)
     * @type {number}
     * @memberof ConstantWind
     */
    directionValue?: number;
}

export function ConstantWindFromJSON(json: any): ConstantWind {
    return {
        'id': !exists(json, 'id') ? undefined : json['id'],
        'uid': !exists(json, 'uid') ? undefined : json['uid'],
        'url': !exists(json, 'url') ? undefined : json['url'],
        'simulation': !exists(json, 'simulation') ? undefined : json['simulation'],
        'offset': json['offset'],
        'duration': !exists(json, 'duration') ? undefined : json['duration'],
        'values': !exists(json, 'values') ? undefined : json['values'],
        'units': !exists(json, 'units') ? undefined : json['units'],
        'speedInterpolate': !exists(json, 'speed_interpolate') ? undefined : json['speed_interpolate'],
        'speedConstant': !exists(json, 'speed_constant') ? undefined : json['speed_constant'],
        'directionInterpolate': !exists(json, 'direction_interpolate') ? undefined : json['direction_interpolate'],
        'directionConstant': !exists(json, 'direction_constant') ? undefined : json['direction_constant'],
        'speedValue': !exists(json, 'speed_value') ? undefined : json['speed_value'],
        'directionValue': !exists(json, 'direction_value') ? undefined : json['direction_value'],
    };
}

export function ConstantWindToJSON(value?: ConstantWind): any {
    if (value === undefined) {
        return undefined;
    }
    return {
        'offset': value.offset,
        'duration': value.duration,
        'units': value.units,
        'speed_value': value.speedValue,
        'direction_value': value.directionValue,
    };
}

/**
* @export
* @enum {string}
*/
export enum ConstantWindUnitsEnum {
    MS = 'm/s',
    KmH = 'km/h'
}


