// tslint:disable
/**
 * 3Di API
 * 3Di simulation API (latest stable version: v3)   Framework release: 3.0.1   3Di core release: 2.3.0.dev0  deployed on:  10:42AM (UTC) on October 04, 2022
 *
 * The version of the OpenAPI document: v3
 * Contact: info@nelen-schuurmans.nl
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { exists, mapValues } from '../runtime';
import {
    FileReadOnly,
    FileReadOnlyFromJSON,
    FileReadOnlyToJSON,
} from './';

/**
 * 
 * @export
 * @interface FileRasterRain
 */
export interface FileRasterRain {
    /**
     * 
     * @type {string}
     * @memberof FileRasterRain
     */
    readonly url?: string;
    /**
     * 
     * @type {number}
     * @memberof FileRasterRain
     */
    multiplier?: number;
    /**
     * 
     * @type {string}
     * @memberof FileRasterRain
     */
    readonly simulation?: string;
    /**
     * offset of event in simulation in seconds
     * @type {number}
     * @memberof FileRasterRain
     */
    offset?: number | null;
    /**
     * Duration of event in seconds
     * @type {number}
     * @memberof FileRasterRain
     */
    duration?: number | null;
    /**
     * in simulation in seconds
     * @type {Array<number>}
     * @memberof FileRasterRain
     */
    timestamps?: Array<number> | null;
    /**
     * interval in seconds
     * @type {number}
     * @memberof FileRasterRain
     */
    interval?: number | null;
    /**
     * 
     * @type {string}
     * @memberof FileRasterRain
     */
    valuesReference?: string | null;
    /**
     * 
     * @type {string}
     * @memberof FileRasterRain
     */
    fillValue?: string;
    /**
     * 
     * @type {string}
     * @memberof FileRasterRain
     */
    units?: FileRasterRainUnitsEnum;
    /**
     * 
     * @type {Array<number>}
     * @memberof FileRasterRain
     */
    geotransform?: Array<number>;
    /**
     * 
     * @type {number}
     * @memberof FileRasterRain
     */
    epsgCode?: number;
    /**
     * 
     * @type {FileReadOnly}
     * @memberof FileRasterRain
     */
    file?: FileReadOnly;
    /**
     * 
     * @type {string}
     * @memberof FileRasterRain
     */
    readonly type?: FileRasterRainTypeEnum;
    /**
     * 
     * @type {string}
     * @memberof FileRasterRain
     */
    readonly uid?: string;
    /**
     * 
     * @type {number}
     * @memberof FileRasterRain
     */
    readonly id?: number;
}

export function FileRasterRainFromJSON(json: any): FileRasterRain {
    return {
        'url': !exists(json, 'url') ? undefined : json['url'],
        'multiplier': !exists(json, 'multiplier') ? undefined : json['multiplier'],
        'simulation': !exists(json, 'simulation') ? undefined : json['simulation'],
        'offset': !exists(json, 'offset') ? undefined : json['offset'],
        'duration': !exists(json, 'duration') ? undefined : json['duration'],
        'timestamps': !exists(json, 'timestamps') ? undefined : json['timestamps'],
        'interval': !exists(json, 'interval') ? undefined : json['interval'],
        'valuesReference': !exists(json, 'values_reference') ? undefined : json['values_reference'],
        'fillValue': !exists(json, 'fill_value') ? undefined : json['fill_value'],
        'units': !exists(json, 'units') ? undefined : json['units'],
        'geotransform': !exists(json, 'geotransform') ? undefined : json['geotransform'],
        'epsgCode': !exists(json, 'epsg_code') ? undefined : json['epsg_code'],
        'file': !exists(json, 'file') ? undefined : FileReadOnlyFromJSON(json['file']),
        'type': !exists(json, 'type') ? undefined : json['type'],
        'uid': !exists(json, 'uid') ? undefined : json['uid'],
        'id': !exists(json, 'id') ? undefined : json['id'],
    };
}

export function FileRasterRainToJSON(value?: FileRasterRain): any {
    if (value === undefined) {
        return undefined;
    }
    return {
        'multiplier': value.multiplier,
        'offset': value.offset,
        'duration': value.duration,
        'timestamps': value.timestamps,
        'interval': value.interval,
        'values_reference': value.valuesReference,
        'fill_value': value.fillValue,
        'units': value.units,
        'geotransform': value.geotransform,
        'epsg_code': value.epsgCode,
        'file': FileReadOnlyToJSON(value.file),
    };
}

/**
* @export
* @enum {string}
*/
export enum FileRasterRainUnitsEnum {
    MS = 'm/s',
    Mm = 'mm',
    MmH = 'mm/h',
    MmHr = 'mm/hr'
}
/**
* @export
* @enum {string}
*/
export enum FileRasterRainTypeEnum {
    Netcdf4 = 'netcdf4'
}


