// tslint:disable
/**
 * 3Di API
 * 3Di simulation API (latest stable version: v3)   Framework release: 3.0.1   3Di core release: 2.3.0.dev0  deployed on:  10:42AM (UTC) on October 04, 2022
 *
 * The version of the OpenAPI document: v3
 * Contact: info@nelen-schuurmans.nl
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { exists, mapValues } from '../runtime';
import {
    Point,
    PointFromJSON,
    PointToJSON,
} from './';

/**
 * 
 * @export
 * @interface Lateral
 */
export interface Lateral {
    /**
     * 
     * @type {string}
     * @memberof Lateral
     */
    readonly url?: string;
    /**
     * 
     * @type {string}
     * @memberof Lateral
     */
    readonly simulation?: string;
    /**
     * offset of event in simulation in seconds
     * @type {number}
     * @memberof Lateral
     */
    offset: number;
    /**
     * event duration in seconds. -9999 is the \'infinite duration\' value (only allowed in conjunction with infinite simulations
     * @type {number}
     * @memberof Lateral
     */
    duration?: number | null;
    /**
     * 
     * @type {boolean}
     * @memberof Lateral
     */
    interpolate?: boolean;
    /**
     * Timeseries provided as a nested list. The inner list consists of exactly 2 values: timestamp, value
     * @type {Array<Array<number>>}
     * @memberof Lateral
     */
    values: Array<Array<number>>;
    /**
     * \'m3/s\' (only option for now)
     * @type {string}
     * @memberof Lateral
     */
    units: LateralUnitsEnum;
    /**
     * 
     * @type {boolean}
     * @memberof Lateral
     */
    constant?: boolean;
    /**
     * 
     * @type {Point}
     * @memberof Lateral
     */
    point?: Point;
    /**
     * 
     * @type {number}
     * @memberof Lateral
     */
    connectionNode?: number | null;
    /**
     * 
     * @type {string}
     * @memberof Lateral
     */
    readonly state?: LateralStateEnum;
    /**
     * 
     * @type {object}
     * @memberof Lateral
     */
    readonly stateDetail?: object;
    /**
     * 
     * @type {number}
     * @memberof Lateral
     */
    readonly gridId?: number;
    /**
     * 
     * @type {string}
     * @memberof Lateral
     */
    readonly uid?: string;
    /**
     * 
     * @type {number}
     * @memberof Lateral
     */
    readonly id?: number;
}

export function LateralFromJSON(json: any): Lateral {
    return {
        'url': !exists(json, 'url') ? undefined : json['url'],
        'simulation': !exists(json, 'simulation') ? undefined : json['simulation'],
        'offset': json['offset'],
        'duration': !exists(json, 'duration') ? undefined : json['duration'],
        'interpolate': !exists(json, 'interpolate') ? undefined : json['interpolate'],
        'values': json['values'],
        'units': json['units'],
        'constant': !exists(json, 'constant') ? undefined : json['constant'],
        'point': !exists(json, 'point') ? undefined : PointFromJSON(json['point']),
        'connectionNode': !exists(json, 'connection_node') ? undefined : json['connection_node'],
        'state': !exists(json, 'state') ? undefined : json['state'],
        'stateDetail': !exists(json, 'state_detail') ? undefined : json['state_detail'],
        'gridId': !exists(json, 'grid_id') ? undefined : json['grid_id'],
        'uid': !exists(json, 'uid') ? undefined : json['uid'],
        'id': !exists(json, 'id') ? undefined : json['id'],
    };
}

export function LateralToJSON(value?: Lateral): any {
    if (value === undefined) {
        return undefined;
    }
    return {
        'offset': value.offset,
        'duration': value.duration,
        'interpolate': value.interpolate,
        'values': value.values,
        'units': value.units,
        'constant': value.constant,
        'point': PointToJSON(value.point),
        'connection_node': value.connectionNode,
    };
}

/**
* @export
* @enum {string}
*/
export enum LateralUnitsEnum {
    M3S = 'm3/s'
}
/**
* @export
* @enum {string}
*/
export enum LateralStateEnum {
    Processing = 'processing',
    Valid = 'valid',
    Invalid = 'invalid'
}


