// tslint:disable
/**
 * 3Di API
 * 3Di simulation API (latest stable version: v3)   Framework release: 3.0.1   3Di core release: 2.3.0.dev0  deployed on:  10:42AM (UTC) on October 04, 2022
 *
 * The version of the OpenAPI document: v3
 * Contact: info@nelen-schuurmans.nl
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { exists, mapValues } from '../runtime';
import {
    Point,
    PointFromJSON,
    PointToJSON,
} from './';

/**
 * 
 * @export
 * @interface LocalRain
 */
export interface LocalRain {
    /**
     * 
     * @type {string}
     * @memberof LocalRain
     */
    readonly url?: string;
    /**
     * 
     * @type {string}
     * @memberof LocalRain
     */
    readonly simulation?: string;
    /**
     * offset of event in simulation in seconds
     * @type {number}
     * @memberof LocalRain
     */
    offset: number;
    /**
     * event duration in seconds. -9999 is the \'infinite duration\' value (only allowed in conjunction with infinite simulations
     * @type {number}
     * @memberof LocalRain
     */
    duration?: number | null;
    /**
     * 
     * @type {boolean}
     * @memberof LocalRain
     */
    interpolate?: boolean;
    /**
     * Timeseries provided as a nested list. The inner list consists of exactly 2 values: timestamp, value
     * @type {Array<Array<number>>}
     * @memberof LocalRain
     */
    values: Array<Array<number>>;
    /**
     * m/s is only option for now
     * @type {string}
     * @memberof LocalRain
     */
    units?: LocalRainUnitsEnum;
    /**
     * 
     * @type {boolean}
     * @memberof LocalRain
     */
    constant?: boolean;
    /**
     * 
     * @type {Point}
     * @memberof LocalRain
     */
    point: Point;
    /**
     * 
     * @type {number}
     * @memberof LocalRain
     */
    diameter: number;
    /**
     * 
     * @type {string}
     * @memberof LocalRain
     */
    readonly uid?: string;
    /**
     * 
     * @type {number}
     * @memberof LocalRain
     */
    readonly id?: number;
}

export function LocalRainFromJSON(json: any): LocalRain {
    return {
        'url': !exists(json, 'url') ? undefined : json['url'],
        'simulation': !exists(json, 'simulation') ? undefined : json['simulation'],
        'offset': json['offset'],
        'duration': !exists(json, 'duration') ? undefined : json['duration'],
        'interpolate': !exists(json, 'interpolate') ? undefined : json['interpolate'],
        'values': json['values'],
        'units': !exists(json, 'units') ? undefined : json['units'],
        'constant': !exists(json, 'constant') ? undefined : json['constant'],
        'point': PointFromJSON(json['point']),
        'diameter': json['diameter'],
        'uid': !exists(json, 'uid') ? undefined : json['uid'],
        'id': !exists(json, 'id') ? undefined : json['id'],
    };
}

export function LocalRainToJSON(value?: LocalRain): any {
    if (value === undefined) {
        return undefined;
    }
    return {
        'offset': value.offset,
        'duration': value.duration,
        'interpolate': value.interpolate,
        'values': value.values,
        'units': value.units,
        'constant': value.constant,
        'point': PointToJSON(value.point),
        'diameter': value.diameter,
    };
}

/**
* @export
* @enum {string}
*/
export enum LocalRainUnitsEnum {
    MS = 'm/s',
    MmH = 'mm/h',
    MmMin = 'mm/min'
}


