// tslint:disable
/**
 * 3Di API
 * 3Di simulation API (latest stable version: v3)   Framework release: 3.0.1   3Di core release: 2.3.0.dev0  deployed on:  10:42AM (UTC) on October 04, 2022
 *
 * The version of the OpenAPI document: v3
 * Contact: info@nelen-schuurmans.nl
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { exists, mapValues } from '../runtime';
import {
    MeasureLocation,
    MeasureLocationFromJSON,
    MeasureLocationToJSON,
} from './';

/**
 * 
 * @export
 * @interface MeasureSpecification
 */
export interface MeasureSpecification {
    /**
     * 
     * @type {number}
     * @memberof MeasureSpecification
     */
    readonly id?: number;
    /**
     * 
     * @type {string}
     * @memberof MeasureSpecification
     */
    name?: string;
    /**
     * 
     * @type {Array<MeasureLocation>}
     * @memberof MeasureSpecification
     */
    locations: Array<MeasureLocation>;
    /**
     * measurement variable, one of the following options:  s1 (waterlevel) vol1 (volume) q (discharge) u1 (velocity) 
     * @type {string}
     * @memberof MeasureSpecification
     */
    variable: MeasureSpecificationVariableEnum;
    /**
     * e.g. >, <, >=, <=
     * @type {string}
     * @memberof MeasureSpecification
     */
    operator: MeasureSpecificationOperatorEnum;
}

export function MeasureSpecificationFromJSON(json: any): MeasureSpecification {
    return {
        'id': !exists(json, 'id') ? undefined : json['id'],
        'name': !exists(json, 'name') ? undefined : json['name'],
        'locations': (json['locations'] as Array<any>).map(MeasureLocationFromJSON),
        'variable': json['variable'],
        'operator': json['operator'],
    };
}

export function MeasureSpecificationToJSON(value?: MeasureSpecification): any {
    if (value === undefined) {
        return undefined;
    }
    return {
        'name': value.name,
        'locations': (value.locations as Array<any>).map(MeasureLocationToJSON),
        'variable': value.variable,
        'operator': value.operator,
    };
}

/**
* @export
* @enum {string}
*/
export enum MeasureSpecificationVariableEnum {
    S1 = 's1',
    Vol1 = 'vol1',
    Q = 'q',
    U1 = 'u1'
}
/**
* @export
* @enum {string}
*/
export enum MeasureSpecificationOperatorEnum {
    GreaterThan = '>',
    GreaterThanOrEqualTo = '>=',
    LessThan = '<',
    LessThanOrEqualTo = '<='
}


