// tslint:disable
/**
 * 3Di API
 * 3Di simulation API (latest stable version: v3)   Framework release: 3.0.1   3Di core release: 2.3.0.dev0  deployed on:  10:42AM (UTC) on October 04, 2022
 *
 * The version of the OpenAPI document: v3
 * Contact: info@nelen-schuurmans.nl
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { exists, mapValues } from '../runtime';
/**
 * 
 * @export
 * @interface ModelFile
 */
export interface ModelFile {
    /**
     * 
     * @type {string}
     * @memberof ModelFile
     */
    readonly url?: string;
    /**
     * 
     * @type {string}
     * @memberof ModelFile
     */
    readonly storageName?: string;
    /**
     * 
     * @type {string}
     * @memberof ModelFile
     */
    filename: string;
    /**
     * 
     * @type {string}
     * @memberof ModelFile
     */
    bucket: string;
    /**
     * 
     * @type {string}
     * @memberof ModelFile
     */
    prefix?: string | null;
    /**
     * Optional eTag (md5sum)
     * @type {string}
     * @memberof ModelFile
     */
    etag?: string | null;
    /**
     * Filesize in bytes
     * @type {number}
     * @memberof ModelFile
     */
    size?: number | null;
    /**
     * 
     * @type {Date}
     * @memberof ModelFile
     */
    expiryDate?: Date;
    /**
     * 
     * @type {string}
     * @memberof ModelFile
     */
    readonly relatedObject?: string;
    /**
     * 
     * @type {string}
     * @memberof ModelFile
     */
    type: ModelFileTypeEnum;
    /**
     * 
     * @type {string}
     * @memberof ModelFile
     */
    state: ModelFileStateEnum;
    /**
     * 
     * @type {string}
     * @memberof ModelFile
     */
    stateDescription?: string | null;
    /**
     * 
     * @type {object}
     * @memberof ModelFile
     */
    meta?: object | null;
    /**
     * 
     * @type {number}
     * @memberof ModelFile
     */
    readonly id?: number;
}

export function ModelFileFromJSON(json: any): ModelFile {
    return {
        'url': !exists(json, 'url') ? undefined : json['url'],
        'storageName': !exists(json, 'storage_name') ? undefined : json['storage_name'],
        'filename': json['filename'],
        'bucket': json['bucket'],
        'prefix': !exists(json, 'prefix') ? undefined : json['prefix'],
        'etag': !exists(json, 'etag') ? undefined : json['etag'],
        'size': !exists(json, 'size') ? undefined : json['size'],
        'expiryDate': !exists(json, 'expiry_date') ? undefined : new Date(json['expiry_date']),
        'relatedObject': !exists(json, 'related_object') ? undefined : json['related_object'],
        'type': json['type'],
        'state': json['state'],
        'stateDescription': !exists(json, 'state_description') ? undefined : json['state_description'],
        'meta': !exists(json, 'meta') ? undefined : json['meta'],
        'id': !exists(json, 'id') ? undefined : json['id'],
    };
}

export function ModelFileToJSON(value?: ModelFile): any {
    if (value === undefined) {
        return undefined;
    }
    return {
        'filename': value.filename,
        'bucket': value.bucket,
        'prefix': value.prefix,
        'etag': value.etag,
        'size': value.size,
        'expiry_date': value.expiryDate === undefined ? undefined : value.expiryDate.toISOString().substr(0,10),
        'type': value.type,
        'state': value.state,
        'state_description': value.stateDescription,
        'meta': value.meta,
    };
}

/**
* @export
* @enum {string}
*/
export enum ModelFileTypeEnum {
    Timeseries = 'timeseries',
    Rastertimeseries = 'rastertimeseries',
    Savedstate = 'savedstate',
    Results = 'results',
    Rasters = 'rasters',
    Gridadmin = 'gridadmin',
    Geojson = 'geojson',
    Initialwaterlevel = 'initialwaterlevel',
    Bulklateral = 'bulklateral',
    Bulkcontrol = 'bulkcontrol',
    BulkBoundaryconditions = 'bulk_boundaryconditions',
    Sqlite = 'sqlite',
    Tables = 'tables'
}
/**
* @export
* @enum {string}
*/
export enum ModelFileStateEnum {
    Created = 'created',
    Uploaded = 'uploaded',
    Processed = 'processed',
    Error = 'error',
    Removed = 'removed'
}


