// tslint:disable
/**
 * 3Di API
 * 3Di simulation API (latest stable version: v3)   Framework release: 3.0.1   3Di core release: 2.3.0.dev0  deployed on:  10:42AM (UTC) on October 04, 2022
 *
 * The version of the OpenAPI document: v3
 * Contact: info@nelen-schuurmans.nl
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { exists, mapValues } from '../runtime';
import {
    Extent,
    ExtentFromJSON,
    ExtentToJSON,
    FileReadOnly,
    FileReadOnlyFromJSON,
    FileReadOnlyToJSON,
} from './';

/**
 * 
 * @export
 * @interface Raster
 */
export interface Raster {
    /**
     * 
     * @type {string}
     * @memberof Raster
     */
    readonly url?: string;
    /**
     * 
     * @type {string}
     * @memberof Raster
     */
    type: RasterTypeEnum;
    /**
     * 
     * @type {string}
     * @memberof Raster
     */
    readonly threedimodel?: string;
    /**
     * 
     * @type {string}
     * @memberof Raster
     */
    name: string;
    /**
     * 
     * @type {FileReadOnly}
     * @memberof Raster
     */
    file?: FileReadOnly;
    /**
     * 
     * @type {number}
     * @memberof Raster
     */
    readonly id?: number;
    /**
     * 
     * @type {number}
     * @memberof Raster
     */
    epsgCode?: number | null;
    /**
     * 
     * @type {Extent}
     * @memberof Raster
     */
    extent?: Extent;
    /**
     * 
     * @type {Array<number>}
     * @memberof Raster
     */
    geotransform?: Array<number> | null;
    /**
     * 
     * @type {string}
     * @memberof Raster
     */
    unit?: RasterUnitEnum;
}

export function RasterFromJSON(json: any): Raster {
    return {
        'url': !exists(json, 'url') ? undefined : json['url'],
        'type': json['type'],
        'threedimodel': !exists(json, 'threedimodel') ? undefined : json['threedimodel'],
        'name': json['name'],
        'file': !exists(json, 'file') ? undefined : FileReadOnlyFromJSON(json['file']),
        'id': !exists(json, 'id') ? undefined : json['id'],
        'epsgCode': !exists(json, 'epsg_code') ? undefined : json['epsg_code'],
        'extent': !exists(json, 'extent') ? undefined : ExtentFromJSON(json['extent']),
        'geotransform': !exists(json, 'geotransform') ? undefined : json['geotransform'],
        'unit': !exists(json, 'unit') ? undefined : json['unit'],
    };
}

export function RasterToJSON(value?: Raster): any {
    if (value === undefined) {
        return undefined;
    }
    return {
        'type': value.type,
        'name': value.name,
        'file': FileReadOnlyToJSON(value.file),
        'epsg_code': value.epsgCode,
        'extent': ExtentToJSON(value.extent),
        'geotransform': value.geotransform,
        'unit': value.unit,
    };
}

/**
* @export
* @enum {string}
*/
export enum RasterTypeEnum {
    DemFile = 'dem_file',
    DemRawFile = 'dem_raw_file',
    EquilibriumInfiltrationRateFile = 'equilibrium_infiltration_rate_file',
    FrictCoefFile = 'frict_coef_file',
    InitialGroundwaterLevelFile = 'initial_groundwater_level_file',
    InitialWaterlevelFile = 'initial_waterlevel_file',
    GroundwaterHydroConnectivityFile = 'groundwater_hydro_connectivity_file',
    GroundwaterImperviousLayerLevelFile = 'groundwater_impervious_layer_level_file',
    InfiltrationDecayPeriodFile = 'infiltration_decay_period_file',
    InitialInfiltrationRateFile = 'initial_infiltration_rate_file',
    LeakageFile = 'leakage_file',
    PhreaticStorageCapacityFile = 'phreatic_storage_capacity_file',
    HydraulicConductivityFile = 'hydraulic_conductivity_file',
    PorosityFile = 'porosity_file',
    InfiltrationRateFile = 'infiltration_rate_file',
    MaxInfiltrationCapacityFile = 'max_infiltration_capacity_file',
    InterceptionFile = 'interception_file'
}
/**
* @export
* @enum {string}
*/
export enum RasterUnitEnum {
    Meters = 'meters'
}


