// tslint:disable
/**
 * 3Di API
 * 3Di simulation API (latest stable version: v3)   Framework release: 3.0.1   3Di core release: 2.3.0.dev0  deployed on:  10:42AM (UTC) on October 04, 2022
 *
 * The version of the OpenAPI document: v3
 * Contact: info@nelen-schuurmans.nl
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { exists, mapValues } from '../runtime';
import {
    Extent,
    ExtentFromJSON,
    ExtentToJSON,
} from './';

/**
 * 
 * @export
 * @interface RasterCreate
 */
export interface RasterCreate {
    /**
     * 
     * @type {string}
     * @memberof RasterCreate
     */
    readonly url?: string;
    /**
     * 
     * @type {string}
     * @memberof RasterCreate
     */
    type: RasterCreateTypeEnum;
    /**
     * 
     * @type {string}
     * @memberof RasterCreate
     */
    name: string;
    /**
     * 
     * @type {number}
     * @memberof RasterCreate
     */
    readonly id?: number;
    /**
     * 
     * @type {number}
     * @memberof RasterCreate
     */
    readonly epsgCode?: number;
    /**
     * 
     * @type {Extent}
     * @memberof RasterCreate
     */
    extent?: Extent;
    /**
     * 
     * @type {Array<number>}
     * @memberof RasterCreate
     */
    readonly geotransform?: Array<number>;
    /**
     * 
     * @type {string}
     * @memberof RasterCreate
     */
    unit?: RasterCreateUnitEnum;
    /**
     * 
     * @type {string}
     * @memberof RasterCreate
     */
    md5sum?: string;
}

export function RasterCreateFromJSON(json: any): RasterCreate {
    return {
        'url': !exists(json, 'url') ? undefined : json['url'],
        'type': json['type'],
        'name': json['name'],
        'id': !exists(json, 'id') ? undefined : json['id'],
        'epsgCode': !exists(json, 'epsg_code') ? undefined : json['epsg_code'],
        'extent': !exists(json, 'extent') ? undefined : ExtentFromJSON(json['extent']),
        'geotransform': !exists(json, 'geotransform') ? undefined : json['geotransform'],
        'unit': !exists(json, 'unit') ? undefined : json['unit'],
        'md5sum': !exists(json, 'md5sum') ? undefined : json['md5sum'],
    };
}

export function RasterCreateToJSON(value?: RasterCreate): any {
    if (value === undefined) {
        return undefined;
    }
    return {
        'type': value.type,
        'name': value.name,
        'extent': ExtentToJSON(value.extent),
        'unit': value.unit,
        'md5sum': value.md5sum,
    };
}

/**
* @export
* @enum {string}
*/
export enum RasterCreateTypeEnum {
    DemFile = 'dem_file',
    EquilibriumInfiltrationRateFile = 'equilibrium_infiltration_rate_file',
    FrictCoefFile = 'frict_coef_file',
    InitialGroundwaterLevelFile = 'initial_groundwater_level_file',
    InitialWaterlevelFile = 'initial_waterlevel_file',
    GroundwaterHydroConnectivityFile = 'groundwater_hydro_connectivity_file',
    GroundwaterImperviousLayerLevelFile = 'groundwater_impervious_layer_level_file',
    InfiltrationDecayPeriodFile = 'infiltration_decay_period_file',
    InitialInfiltrationRateFile = 'initial_infiltration_rate_file',
    LeakageFile = 'leakage_file',
    PhreaticStorageCapacityFile = 'phreatic_storage_capacity_file',
    HydraulicConductivityFile = 'hydraulic_conductivity_file',
    PorosityFile = 'porosity_file',
    InfiltrationRateFile = 'infiltration_rate_file',
    MaxInfiltrationCapacityFile = 'max_infiltration_capacity_file',
    InterceptionFile = 'interception_file'
}
/**
* @export
* @enum {string}
*/
export enum RasterCreateUnitEnum {
    Meters = 'meters'
}


