// tslint:disable
/**
 * 3Di API
 * 3Di simulation API (latest stable version: v3)   Framework release: 3.0.1   3Di core release: 2.3.0.dev0  deployed on:  10:42AM (UTC) on October 04, 2022
 *
 * The version of the OpenAPI document: v3
 * Contact: info@nelen-schuurmans.nl
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { exists, mapValues } from '../runtime';
import {
    FileReadOnly,
    FileReadOnlyFromJSON,
    FileReadOnlyToJSON,
    Threshold,
    ThresholdFromJSON,
    ThresholdToJSON,
} from './';

/**
 * 
 * @export
 * @interface SavedStateOverview
 */
export interface SavedStateOverview {
    /**
     * 
     * @type {string}
     * @memberof SavedStateOverview
     */
    name?: string;
    /**
     * 
     * @type {string}
     * @memberof SavedStateOverview
     */
    type: SavedStateOverviewTypeEnum;
    /**
     * 
     * @type {Date}
     * @memberof SavedStateOverview
     */
    created?: Date | null;
    /**
     * Time in simulation the savedstate has been created
     * @type {number}
     * @memberof SavedStateOverview
     */
    createdTime?: number | null;
    /**
     * tags provided as a list of strings
     * @type {Array<string>}
     * @memberof SavedStateOverview
     */
    tags?: Array<string>;
    /**
     * 
     * @type {Date}
     * @memberof SavedStateOverview
     */
    expiry?: Date | null;
    /**
     * Time in simulation to create savedstate
     * @type {number}
     * @memberof SavedStateOverview
     */
    time?: number | null;
    /**
     * 
     * @type {Array<Threshold>}
     * @memberof SavedStateOverview
     */
    thresholds: Array<Threshold>;
    /**
     * 
     * @type {FileReadOnly}
     * @memberof SavedStateOverview
     */
    file?: FileReadOnly;
    /**
     * 
     * @type {number}
     * @memberof SavedStateOverview
     */
    readonly id?: number;
    /**
     * 
     * @type {string}
     * @memberof SavedStateOverview
     */
    uuid?: string;
}

export function SavedStateOverviewFromJSON(json: any): SavedStateOverview {
    return {
        'name': !exists(json, 'name') ? undefined : json['name'],
        'type': json['type'],
        'created': !exists(json, 'created') ? undefined : new Date(json['created']),
        'createdTime': !exists(json, 'created_time') ? undefined : json['created_time'],
        'tags': !exists(json, 'tags') ? undefined : json['tags'],
        'expiry': !exists(json, 'expiry') ? undefined : new Date(json['expiry']),
        'time': !exists(json, 'time') ? undefined : json['time'],
        'thresholds': (json['thresholds'] as Array<any>).map(ThresholdFromJSON),
        'file': !exists(json, 'file') ? undefined : FileReadOnlyFromJSON(json['file']),
        'id': !exists(json, 'id') ? undefined : json['id'],
        'uuid': !exists(json, 'uuid') ? undefined : json['uuid'],
    };
}

export function SavedStateOverviewToJSON(value?: SavedStateOverview): any {
    if (value === undefined) {
        return undefined;
    }
    return {
        'name': value.name,
        'type': value.type,
        'created': value.created === undefined ? undefined : value.created.toISOString(),
        'created_time': value.createdTime,
        'tags': value.tags,
        'expiry': value.expiry === undefined ? undefined : value.expiry.toISOString(),
        'time': value.time,
        'thresholds': (value.thresholds as Array<any>).map(ThresholdToJSON),
        'file': FileReadOnlyToJSON(value.file),
        'uuid': value.uuid,
    };
}

/**
* @export
* @enum {string}
*/
export enum SavedStateOverviewTypeEnum {
    StableThreshold = 'stable_threshold',
    Timed = 'timed'
}


