// tslint:disable
/**
 * 3Di API
 * 3Di simulation API (latest stable version: v3)   Framework release: 3.0.1   3Di core release: 2.3.0.dev0  deployed on:  10:42AM (UTC) on October 04, 2022
 *
 * The version of the OpenAPI document: v3
 * Contact: info@nelen-schuurmans.nl
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { exists, mapValues } from '../runtime';
import {
    MeasureSpecification,
    MeasureSpecificationFromJSON,
    MeasureSpecificationToJSON,
} from './';

/**
 * 
 * @export
 * @interface TableStructureControl
 */
export interface TableStructureControl {
    /**
     * 
     * @type {number}
     * @memberof TableStructureControl
     */
    readonly id?: number;
    /**
     * 
     * @type {string}
     * @memberof TableStructureControl
     */
    readonly url?: string;
    /**
     * offset of event in simulation in seconds
     * @type {number}
     * @memberof TableStructureControl
     */
    offset: number;
    /**
     * event duration in seconds. -9999 is the \'infinite duration\' value (only allowed in conjunction with infinite simulations
     * @type {number}
     * @memberof TableStructureControl
     */
    duration?: number | null;
    /**
     * 
     * @type {MeasureSpecification}
     * @memberof TableStructureControl
     */
    measureSpecification: MeasureSpecification;
    /**
     * 
     * @type {number}
     * @memberof TableStructureControl
     */
    structureId?: number | null;
    /**
     * 
     * @type {string}
     * @memberof TableStructureControl
     */
    structureType: TableStructureControlStructureTypeEnum;
    /**
     * 
     * @type {string}
     * @memberof TableStructureControl
     */
    type: TableStructureControlTypeEnum;
    /**
     * 
     * @type {Array<Array<number>>}
     * @memberof TableStructureControl
     */
    values: Array<Array<number>>;
    /**
     * 
     * @type {string}
     * @memberof TableStructureControl
     */
    readonly state?: TableStructureControlStateEnum;
    /**
     * 
     * @type {object}
     * @memberof TableStructureControl
     */
    readonly stateDetail?: object;
    /**
     * 
     * @type {number}
     * @memberof TableStructureControl
     */
    gridId?: number | null;
    /**
     * 
     * @type {string}
     * @memberof TableStructureControl
     */
    readonly uid?: string;
}

export function TableStructureControlFromJSON(json: any): TableStructureControl {
    return {
        'id': !exists(json, 'id') ? undefined : json['id'],
        'url': !exists(json, 'url') ? undefined : json['url'],
        'offset': json['offset'],
        'duration': !exists(json, 'duration') ? undefined : json['duration'],
        'measureSpecification': MeasureSpecificationFromJSON(json['measure_specification']),
        'structureId': !exists(json, 'structure_id') ? undefined : json['structure_id'],
        'structureType': json['structure_type'],
        'type': json['type'],
        'values': json['values'],
        'state': !exists(json, 'state') ? undefined : json['state'],
        'stateDetail': !exists(json, 'state_detail') ? undefined : json['state_detail'],
        'gridId': !exists(json, 'grid_id') ? undefined : json['grid_id'],
        'uid': !exists(json, 'uid') ? undefined : json['uid'],
    };
}

export function TableStructureControlToJSON(value?: TableStructureControl): any {
    if (value === undefined) {
        return undefined;
    }
    return {
        'offset': value.offset,
        'duration': value.duration,
        'measure_specification': MeasureSpecificationToJSON(value.measureSpecification),
        'structure_id': value.structureId,
        'structure_type': value.structureType,
        'type': value.type,
        'values': value.values,
        'grid_id': value.gridId,
    };
}

/**
* @export
* @enum {string}
*/
export enum TableStructureControlStructureTypeEnum {
    Pumpstation = 'v2_pumpstation',
    Pipe = 'v2_pipe',
    Orifice = 'v2_orifice',
    Culvert = 'v2_culvert',
    Weir = 'v2_weir',
    Channel = 'v2_channel'
}
/**
* @export
* @enum {string}
*/
export enum TableStructureControlTypeEnum {
    DischargeCoefficients = 'set_discharge_coefficients',
    CrestLevel = 'set_crest_level',
    PumpCapacity = 'set_pump_capacity'
}
/**
* @export
* @enum {string}
*/
export enum TableStructureControlStateEnum {
    Processing = 'processing',
    Valid = 'valid',
    Invalid = 'invalid'
}


