// tslint:disable
/**
 * 3Di API
 * 3Di simulation API (latest stable version: v3)   Framework release: 3.0.1   3Di core release: 2.3.0.dev0  deployed on:  10:42AM (UTC) on October 04, 2022
 *
 * The version of the OpenAPI document: v3
 * Contact: info@nelen-schuurmans.nl
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { exists, mapValues } from '../runtime';
import {
    Extent,
    ExtentFromJSON,
    ExtentToJSON,
} from './';

/**
 * 
 * @export
 * @interface ThreediModel
 */
export interface ThreediModel {
    /**
     * 
     * @type {string}
     * @memberof ThreediModel
     */
    readonly url?: string;
    /**
     * 
     * @type {number}
     * @memberof ThreediModel
     */
    readonly id?: number;
    /**
     * The username of a user
     * @type {string}
     * @memberof ThreediModel
     */
    readonly user?: string;
    /**
     * The 3Di API version that created this threedimodel.
     * @type {string}
     * @memberof ThreediModel
     */
    readonly threediVersion?: string;
    /**
     * 
     * @type {string}
     * @memberof ThreediModel
     */
    revision: string;
    /**
     * 
     * @type {number}
     * @memberof ThreediModel
     */
    readonly revisionId?: number;
    /**
     * 
     * @type {string}
     * @memberof ThreediModel
     */
    readonly revisionHash?: string;
    /**
     * 
     * @type {string}
     * @memberof ThreediModel
     */
    readonly revisionNumber?: string;
    /**
     * 
     * @type {string}
     * @memberof ThreediModel
     */
    readonly revisionCommitDate?: string;
    /**
     * 
     * @type {number}
     * @memberof ThreediModel
     */
    readonly schematisationId?: number;
    /**
     * 
     * @type {string}
     * @memberof ThreediModel
     */
    readonly schematisationName?: string;
    /**
     * 
     * @type {string}
     * @memberof ThreediModel
     */
    readonly repositorySlug?: string;
    /**
     * 
     * @type {string}
     * @memberof ThreediModel
     */
    name?: string;
    /**
     * 
     * @type {string}
     * @memberof ThreediModel
     */
    slug: string;
    /**
     * Disable the model.
     * @type {boolean}
     * @memberof ThreediModel
     */
    disabled?: boolean;
    /**
     * True if the threedimodel was generated without errors.
     * @type {boolean}
     * @memberof ThreediModel
     */
    isValid?: boolean | null;
    /**
     * 
     * @type {number}
     * @memberof ThreediModel
     */
    epsg?: number | null;
    /**
     * Please describe the model here...
     * @type {string}
     * @memberof ThreediModel
     */
    description?: string | null;
    /**
     * Automatically filled after threedimodel generation.
     * @type {number}
     * @memberof ThreediModel
     */
    storageSpace?: number;
    /**
     * 
     * @type {string}
     * @memberof ThreediModel
     */
    readonly storageSpaceHumanized?: string;
    /**
     * 
     * @type {string}
     * @memberof ThreediModel
     */
    modelIni?: string | null;
    /**
     * 
     * @type {string}
     * @memberof ThreediModel
     */
    readonly breachCount?: string;
    /**
     * 
     * @type {Extent}
     * @memberof ThreediModel
     */
    extentTwoD?: Extent;
    /**
     * 
     * @type {Extent}
     * @memberof ThreediModel
     */
    extentOneD?: Extent;
    /**
     * 
     * @type {Extent}
     * @memberof ThreediModel
     */
    extentZeroD?: Extent;
    /**
     * 
     * @type {number}
     * @memberof ThreediModel
     */
    nodesCount?: number | null;
    /**
     * 
     * @type {number}
     * @memberof ThreediModel
     */
    linesCount?: number | null;
    /**
     * 
     * @type {string}
     * @memberof ThreediModel
     */
    inpyVersion: string;
    /**
     * 
     * @type {boolean}
     * @memberof ThreediModel
     */
    inpSuccess?: boolean;
}

export function ThreediModelFromJSON(json: any): ThreediModel {
    return {
        'url': !exists(json, 'url') ? undefined : json['url'],
        'id': !exists(json, 'id') ? undefined : json['id'],
        'user': !exists(json, 'user') ? undefined : json['user'],
        'threediVersion': !exists(json, 'threedi_version') ? undefined : json['threedi_version'],
        'revision': json['revision'],
        'revisionId': !exists(json, 'revision_id') ? undefined : json['revision_id'],
        'revisionHash': !exists(json, 'revision_hash') ? undefined : json['revision_hash'],
        'revisionNumber': !exists(json, 'revision_number') ? undefined : json['revision_number'],
        'revisionCommitDate': !exists(json, 'revision_commit_date') ? undefined : json['revision_commit_date'],
        'schematisationId': !exists(json, 'schematisation_id') ? undefined : json['schematisation_id'],
        'schematisationName': !exists(json, 'schematisation_name') ? undefined : json['schematisation_name'],
        'repositorySlug': !exists(json, 'repository_slug') ? undefined : json['repository_slug'],
        'name': !exists(json, 'name') ? undefined : json['name'],
        'slug': json['slug'],
        'disabled': !exists(json, 'disabled') ? undefined : json['disabled'],
        'isValid': !exists(json, 'is_valid') ? undefined : json['is_valid'],
        'epsg': !exists(json, 'epsg') ? undefined : json['epsg'],
        'description': !exists(json, 'description') ? undefined : json['description'],
        'storageSpace': !exists(json, 'storage_space') ? undefined : json['storage_space'],
        'storageSpaceHumanized': !exists(json, 'storage_space_humanized') ? undefined : json['storage_space_humanized'],
        'modelIni': !exists(json, 'model_ini') ? undefined : json['model_ini'],
        'breachCount': !exists(json, 'breach_count') ? undefined : json['breach_count'],
        'extentTwoD': !exists(json, 'extent_two_d') ? undefined : ExtentFromJSON(json['extent_two_d']),
        'extentOneD': !exists(json, 'extent_one_d') ? undefined : ExtentFromJSON(json['extent_one_d']),
        'extentZeroD': !exists(json, 'extent_zero_d') ? undefined : ExtentFromJSON(json['extent_zero_d']),
        'nodesCount': !exists(json, 'nodes_count') ? undefined : json['nodes_count'],
        'linesCount': !exists(json, 'lines_count') ? undefined : json['lines_count'],
        'inpyVersion': json['inpy_version'],
        'inpSuccess': !exists(json, 'inp_success') ? undefined : json['inp_success'],
    };
}

export function ThreediModelToJSON(value?: ThreediModel): any {
    if (value === undefined) {
        return undefined;
    }
    return {
        'revision': value.revision,
        'name': value.name,
        'slug': value.slug,
        'disabled': value.disabled,
        'is_valid': value.isValid,
        'epsg': value.epsg,
        'description': value.description,
        'storage_space': value.storageSpace,
        'model_ini': value.modelIni,
        'extent_two_d': ExtentToJSON(value.extentTwoD),
        'extent_one_d': ExtentToJSON(value.extentOneD),
        'extent_zero_d': ExtentToJSON(value.extentZeroD),
        'nodes_count': value.nodesCount,
        'lines_count': value.linesCount,
        'inpy_version': value.inpyVersion,
        'inp_success': value.inpSuccess,
    };
}


