// tslint:disable
/**
 * 3Di API
 * 3Di simulation API (latest stable version: v3)   Framework release: 3.0.1   3Di core release: 2.3.0.dev0  deployed on:  10:42AM (UTC) on October 04, 2022
 *
 * The version of the OpenAPI document: v3
 * Contact: info@nelen-schuurmans.nl
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { exists, mapValues } from '../runtime';
/**
 * 
 * @export
 * @interface TimeStepSettings
 */
export interface TimeStepSettings {
    /**
     * 
     * @type {number}
     * @memberof TimeStepSettings
     */
    readonly id?: number;
    /**
     * 
     * @type {number}
     * @memberof TimeStepSettings
     */
    readonly simulationId?: number;
    /**
     * Size of the simulation time step in seconds.
     * @type {number}
     * @memberof TimeStepSettings
     */
    timeStep: number;
    /**
     * Minimum size of the simulation time step in seconds. Suitable default is 0.001.
     * @type {number}
     * @memberof TimeStepSettings
     */
    minTimeStep: number;
    /**
     * Only in combination with use_time_step_stretch=True.
     * @type {number}
     * @memberof TimeStepSettings
     */
    maxTimeStep?: number | null;
    /**
     * Permit the time step to increase automatically, when the flow allows it.
     * @type {boolean}
     * @memberof TimeStepSettings
     */
    useTimeStepStretch: boolean;
    /**
     * The interval in seconds in which results are saved to disk.
     * @type {number}
     * @memberof TimeStepSettings
     */
    outputTimeStep: number;
}

export function TimeStepSettingsFromJSON(json: any): TimeStepSettings {
    return {
        'id': !exists(json, 'id') ? undefined : json['id'],
        'simulationId': !exists(json, 'simulation_id') ? undefined : json['simulation_id'],
        'timeStep': json['time_step'],
        'minTimeStep': json['min_time_step'],
        'maxTimeStep': !exists(json, 'max_time_step') ? undefined : json['max_time_step'],
        'useTimeStepStretch': json['use_time_step_stretch'],
        'outputTimeStep': json['output_time_step'],
    };
}

export function TimeStepSettingsToJSON(value?: TimeStepSettings): any {
    if (value === undefined) {
        return undefined;
    }
    return {
        'time_step': value.timeStep,
        'min_time_step': value.minTimeStep,
        'max_time_step': value.maxTimeStep,
        'use_time_step_stretch': value.useTimeStepStretch,
        'output_time_step': value.outputTimeStep,
    };
}


