// tslint:disable
/**
 * 3Di API
 * 3Di simulation API (latest stable version: v3)   Framework release: 3.0.1   3Di core release: 2.3.0.dev0  deployed on:  10:42AM (UTC) on October 04, 2022
 *
 * The version of the OpenAPI document: v3
 * Contact: info@nelen-schuurmans.nl
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { exists, mapValues } from '../runtime';
/**
 * 
 * @export
 * @interface TimeseriesWind
 */
export interface TimeseriesWind {
    /**
     * 
     * @type {number}
     * @memberof TimeseriesWind
     */
    readonly id?: number;
    /**
     * 
     * @type {string}
     * @memberof TimeseriesWind
     */
    readonly uid?: string;
    /**
     * 
     * @type {string}
     * @memberof TimeseriesWind
     */
    readonly url?: string;
    /**
     * 
     * @type {string}
     * @memberof TimeseriesWind
     */
    readonly simulation?: string;
    /**
     * offset of event in simulation in seconds
     * @type {number}
     * @memberof TimeseriesWind
     */
    offset: number;
    /**
     * [time, speed, direction]
     * @type {Array<Array<number>>}
     * @memberof TimeseriesWind
     */
    values?: Array<Array<number>>;
    /**
     * wind speed unit (default \'m/s\')
     * @type {string}
     * @memberof TimeseriesWind
     */
    units?: TimeseriesWindUnitsEnum;
    /**
     * interpolate wind speed
     * @type {boolean}
     * @memberof TimeseriesWind
     */
    speedInterpolate?: boolean;
    /**
     * constant wind speed
     * @type {boolean}
     * @memberof TimeseriesWind
     */
    readonly speedConstant?: boolean;
    /**
     * interpolate wind direction
     * @type {boolean}
     * @memberof TimeseriesWind
     */
    directionInterpolate?: boolean;
    /**
     * constant wind direction
     * @type {boolean}
     * @memberof TimeseriesWind
     */
    readonly directionConstant?: boolean;
}

export function TimeseriesWindFromJSON(json: any): TimeseriesWind {
    return {
        'id': !exists(json, 'id') ? undefined : json['id'],
        'uid': !exists(json, 'uid') ? undefined : json['uid'],
        'url': !exists(json, 'url') ? undefined : json['url'],
        'simulation': !exists(json, 'simulation') ? undefined : json['simulation'],
        'offset': json['offset'],
        'values': !exists(json, 'values') ? undefined : json['values'],
        'units': !exists(json, 'units') ? undefined : json['units'],
        'speedInterpolate': !exists(json, 'speed_interpolate') ? undefined : json['speed_interpolate'],
        'speedConstant': !exists(json, 'speed_constant') ? undefined : json['speed_constant'],
        'directionInterpolate': !exists(json, 'direction_interpolate') ? undefined : json['direction_interpolate'],
        'directionConstant': !exists(json, 'direction_constant') ? undefined : json['direction_constant'],
    };
}

export function TimeseriesWindToJSON(value?: TimeseriesWind): any {
    if (value === undefined) {
        return undefined;
    }
    return {
        'offset': value.offset,
        'values': value.values,
        'units': value.units,
        'speed_interpolate': value.speedInterpolate,
        'direction_interpolate': value.directionInterpolate,
    };
}

/**
* @export
* @enum {string}
*/
export enum TimeseriesWindUnitsEnum {
    MS = 'm/s',
    KmH = 'km/h'
}


