// tslint:disable
/**
 * 3Di API
 * 3Di simulation API (latest stable version: v3)   Framework release: 3.0.1   3Di core release: 2.3.0.dev0  deployed on:  10:42AM (UTC) on October 04, 2022
 *
 * The version of the OpenAPI document: v3
 * Contact: info@nelen-schuurmans.nl
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { exists, mapValues } from '../runtime';
/**
 * 
 * @export
 * @interface UserTokens
 */
export interface UserTokens {
    /**
     * 
     * @type {number}
     * @memberof UserTokens
     */
    user: number;
    /**
     * The user ID in the external identity provider, which is present as the \'sub\' field in tokens.
     * @type {string}
     * @memberof UserTokens
     */
    externalUserId: string;
    /**
     * 
     * @type {Date}
     * @memberof UserTokens
     */
    readonly created?: Date;
    /**
     * The last time this remote user logged in.
     * @type {Date}
     * @memberof UserTokens
     */
    readonly lastModified?: Date;
    /**
     * The most recent ID token provided by the external identity provider.
     * @type {string}
     * @memberof UserTokens
     */
    idToken?: string;
    /**
     * The most recent access token provided by the external identity provider.
     * @type {string}
     * @memberof UserTokens
     */
    accessToken?: string;
    /**
     * The most recent refresh token provided by the external identity provider.
     * @type {string}
     * @memberof UserTokens
     */
    refreshToken?: string;
}

export function UserTokensFromJSON(json: any): UserTokens {
    return {
        'user': json['user'],
        'externalUserId': json['external_user_id'],
        'created': !exists(json, 'created') ? undefined : new Date(json['created']),
        'lastModified': !exists(json, 'last_modified') ? undefined : new Date(json['last_modified']),
        'idToken': !exists(json, 'id_token') ? undefined : json['id_token'],
        'accessToken': !exists(json, 'access_token') ? undefined : json['access_token'],
        'refreshToken': !exists(json, 'refresh_token') ? undefined : json['refresh_token'],
    };
}

export function UserTokensToJSON(value?: UserTokens): any {
    if (value === undefined) {
        return undefined;
    }
    return {
        'user': value.user,
        'external_user_id': value.externalUserId,
        'id_token': value.idToken,
        'access_token': value.accessToken,
        'refresh_token': value.refreshToken,
    };
}


